' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Imports System.Runtime.InteropServices
Module UnmanagedMutex
    Public Const LMEM_ZEROINIT As Integer = &H40
#If Not Win32 Then
    <DllImport("coredll.dll", EntryPoint:="#33", SetLastError:=True)> _
    Public Function LocalAlloc(ByVal flags As Integer, ByVal byteCount As Integer) As IntPtr
    End Function
    <DllImport("coredll.dll", EntryPoint:="#36", SetLastError:=True)> _
    Public Function LocalFree(ByVal hMem As IntPtr) As IntPtr
    End Function
    <DllImport("coredll.dll", EntryPoint:="CreateEvent", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function CreateEvent(ByVal lpEventAttributes As IntPtr, ByVal bManualReset As Integer, ByVal bInitialState As Integer, ByVal lpName As String) As IntPtr
    End Function
    <DllImport("coredll.dll", EntryPoint:="EventModify", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Private Function EventModify(ByVal hHandle As IntPtr, ByVal dwFunc As Integer) As Integer
    End Function
    Public Function SetEvent(ByVal hHandle As IntPtr) As Integer
        Return EventModify(hHandle, 3)
    End Function
    Public Function ResetEvent(ByVal hHandle As IntPtr) As Integer
        Return EventModify(hHandle, 2)
    End Function
    Public Const waitFailed As Integer = -1
#Else
    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Function LocalAlloc(ByVal flags As Integer, ByVal byteCount As Integer) As IntPtr
    End Function
    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Function LocalFree(ByVal hMem As IntPtr) As IntPtr
    End Function
    <DllImport("kernel32.dll", EntryPoint:="CreateEvent", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function CreateEvent(ByVal lpEventAttributes As IntPtr, ByVal bManualReset As Integer, ByVal bInitialState As Integer, ByVal lpName As String) As IntPtr
    End Function
    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function ResetEvent(ByVal hHandle As IntPtr) As Integer
    End Function
    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function SetEvent(ByVal hHandle As IntPtr) As Integer
    End Function
    Public Const waitFailed As Integer = -1
#End If
#If Not Win32 Then
    <DllImport("coredll.dll", EntryPoint:="WaitForMultipleObjects", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function WaitForMultipleObjects(ByVal nCount As Integer, ByVal lpHandles As IntPtr, ByVal fWaitAll As Integer, ByVal dwMilliseconds As Integer) As Integer
    End Function
    <DllImport("coredll.dll", EntryPoint:="CloseHandle", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function CloseHandle(ByVal hObject As IntPtr) As Integer
    End Function
#Else
    <DllImport("kernel32.dll", EntryPoint:="WaitForMultipleObjects", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function WaitForMultipleObjects(ByVal nCount As Integer, ByVal lpHandles As IntPtr, ByVal fWaitAll As Integer, ByVal dwMilliseconds As Integer) As Integer
    End Function
    <DllImport("kernel32.dll", EntryPoint:="CloseHandle", SetLastError:=True, CharSet:=CharSet.Unicode, CallingConvention:=CallingConvention.Winapi)> _
    Public Function CloseHandle(ByVal hObject As IntPtr) As Integer
    End Function
#End If
End Module
