' Copyright 2010 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.IO
Public Class TileToolMain
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        With FolderBrowserDialog1
            .ShowNewFolderButton = False
            .Description = "Please select a tiles root-folder for input."
        End With
        If FolderBrowserDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            Dim rootDirectory As String = FolderBrowserDialog1.SelectedPath
            If IO.Directory.Exists(rootDirectory) Then
                With FolderBrowserDialog1
                    .ShowNewFolderButton = True
                    .Description = "Please select a tiles root-folder for output."
                End With
                If FolderBrowserDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                    Dim outputRootDirectory As String = FolderBrowserDialog1.SelectedPath
                    Me.Cursor = Cursors.WaitCursor
                    'Windows.Forms.Cursor.Current = Cursors.WaitCursor
                    For Each zoomFolder As String In Directory.GetDirectories(rootDirectory)
                        Dim zoom As Byte = CByte(New IO.DirectoryInfo(zoomFolder).Name)
                        For Each xFolder As String In Directory.GetDirectories(zoomFolder)
                            ' make sure it's ordered!
                            Dim files() As String = Directory.GetFiles(xFolder, "*.png")
                            If files.Length > 0 Then
                                If Not IO.Directory.Exists(outputRootDirectory & "\" & zoom) Then
                                    IO.Directory.CreateDirectory(outputRootDirectory & "\" & zoom)
                                End If
                                Dim x As Integer = CInt(New IO.DirectoryInfo(xFolder).Name)
                                Dim outputStream As New IO.FileStream(outputRootDirectory & "\" & zoom & "\" & x & ".tiles", IO.FileMode.Create)
                                Dim output As New IO.BinaryWriter(outputStream)
                                output.Write(New Byte() {79, 83, 77, 116, 84, 105, 108, 101})
                                output.Write(zoom)
                                output.Write(x)
                                For Each file As String In files
                                    Dim startpos As Integer = file.LastIndexOf("\") + 2
                                    Dim y As Integer = CInt(Mid(file, startpos, file.Length - 3 - startpos))

                                    Dim a As New IO.FileInfo(file)
                                    Dim fileContents As Byte() = My.Computer.FileSystem.ReadAllBytes(file)

                                    output.Write(y)
                                    output.Write(a.LastWriteTime.ToFileTime)
                                    output.Write(fileContents.Length)
                                    output.Write(fileContents)
                                Next
                                output.Close()
                                Application.DoEvents()
                            End If
                        Next
                    Next
                End If
                MsgBox("Done")
                Me.Cursor = Cursors.Default
            End If
        End If
    End Sub
    Private Sub AboutButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutButton.Click
        frmAbout.ShowDialog()
    End Sub
End Class
